/**	\file Split.h
 **	\date  2008-05-26
 **	\author grymse@alhem.net
**/
/*
Copyright (C) 2008-2009  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _Split_H
#define _Split_H

#include <Sockets/Parse.h>


class Split
{
public:
	Split(const std::string& name) {
		if (!name.empty() && name[0] == ':')
		{
			Type = name.substr(1);
		}
		else
		if (name.find(":") != std::string::npos)
		{
			Parse pa(name, ":");

			NS = pa.getword();
			Type = pa.getword();
		}
		else
		{
			Type = name;
		}
		for (size_t i = 0; i < Type.size(); i++)
			switch (Type[i])
			{
			case '':
				CName += "aa";
				break;
			case '':
				CName += "ae";
				break;
			case '':
				CName += "oe";
				break;
			case '':
				CName += "Aa";
				break;
			case '':
				CName += "Ae";
				break;
			case '':
				CName += "Oe";
				break;
			default:
				if (!isalnum(Type[i]))
					CName += "_";
				else
					CName += Type[i];
			}
		CName1up = CName;
		if (!CName1up.empty() && CName1up[0] >= 'a' && CName1up[0] <= 'z')
			CName1up[0] = (char)CName1up[0] - 32;
	}

	std::string NS;
	std::string Type;

	std::string CName;
	std::string CName1up;

protected:
	Split(const Split& ) {} // copy constructor

private:
	Split& operator=(const Split& ) { return *this; } // assignment operator

};




#endif // _Split_H
